#include <stdio.h>
#include <string.h> /* per strncpy */
#define NUMESAMI 29

int main()
{
	int i = 0;
	int numstudenti = 0;
	struct studente /* struct: parola chiave. studente: indicatore o tag (opzionale) */
	{
		char nome[128]; /* membro */
		int matricola;  /* membro */
		char facolta[128]; /* membro */
	} gianni; /* definisce gianni, dichiarandolo e riservando lo spazio in memoria (analogo a int x; ) */

	struct studente rita = { "Rita Rossi", 45321, "Ingegneria Navale" }; /* dichiara, definisce e inizializza */

	struct studente fortunato; 

	struct studente studenti[100]; /* vettore di strutture */

	studenti[numstudenti++] = rita; /* copia tra struct: si puo`! */

	/* assegno dei valori in modo esplicito ad una struttura, campo per campo */
	strcpy(gianni.nome, "Gianni Verdi");
	gianni.matricola = 45678;
	strcpy(gianni.facolta, "Ingegneria Industriale");

	/* aggiungo l'elemento gianni al vettore di strutture studenti */
	studenti[numstudenti++] = gianni; /* copia tra strutture */
	
	/* fortunato di nome e di fatto */
	fortunato = rita; /* perche` viene inizializzato al volo grazie all'operatore di assegnazione, valido per strutture! */
	
	/* rita e fortunato appartengono alla stessa facolta` */
	strcpy(fortunato.nome, "Fortunato Bianchi");
	fortunato.matricola = rita.matricola + 10;

	studenti[numstudenti++] = fortunato;

	/* !!! NON SI POSSONO CONFRONTARE DUE STRUTTURE!!! */
	// error: invalid operands to binary == (have ‘struct studente’ and ‘struct studente’)
//	if(fortunato == rita)
//		printf("%s e %s hanno la stessa matricola (%d), nome e cognome!", fortunato.nome, rita.nome, fortunato.matricola);

	/* invece, per confrontare due studenti, devo confrontare campo per campo! */
	if(fortunato.matricola == rita.matricola)
		printf("%s e %s hanno la stessa matricola (%d), nome e cognome!", fortunato.nome, rita.nome, fortunato.matricola);

	/* stampiamo una tabellina */
	printf("\n%30s|%10s|%30s|\n", "Studente", "Matricola", "Facolta`");

	for(i = 0; i < numstudenti; i++)
	{
		/* "%30s" aumenta a 30 la lunghezza del campo per scrivere nome e cognome.
		 * L'effetto e` allineare a destra se nome e cognome occupano fino a 30 caratteri.
		 */
		printf("%30s %10d %30s\n", studenti[i].nome, studenti[i].matricola, studenti[i].facolta);
	}
}

